/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 7.0.4
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */

"use strict";var stringRemoveDuplicateHeadsTails=(()=>{var S=Object.defineProperty;var te=Object.getOwnPropertyDescriptor;var re=Object.getOwnPropertyNames,W=Object.getOwnPropertySymbols;var j=Object.prototype.hasOwnProperty,ne=Object.prototype.propertyIsEnumerable;var F=(e,s,i)=>s in e?S(e,s,{enumerable:!0,configurable:!0,writable:!0,value:i}):e[s]=i,y=(e,s)=>{for(var i in s||(s={}))j.call(s,i)&&F(e,i,s[i]);if(W)for(var i of W(s))ne.call(s,i)&&F(e,i,s[i]);return e};var se=(e,s)=>{for(var i in s)S(e,i,{get:s[i],enumerable:!0})},ie=(e,s,i,n)=>{if(s&&typeof s=="object"||typeof s=="function")for(let u of re(s))!j.call(e,u)&&u!==i&&S(e,u,{get:()=>s[u],enumerable:!(n=te(s,u))||n.enumerable});return e};var ae=e=>ie(S({},"__esModule",{value:!0}),e);var x=(e,s,i)=>(F(e,typeof s!="symbol"?s+"":s,i),i);var $e={};se($e,{defaults:()=>Z,remDup:()=>ye,version:()=>de});function L(e){if(e==null||typeof e!="object")return!1;let s=Object.getPrototypeOf(e);return s!==null&&s!==Object.prototype&&Object.getPrototypeOf(s)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function N(e){return typeof e!="string"?e:e.length?[e]:[]}function B(e){return!!e&&typeof e=="object"&&!Array.isArray(e)}function _(e){return typeof e=="string"}var q={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},oe=e=>e+1;function le(e,s,i,n,u=!1,t=oe){let o=typeof i=="function"?i():i;if(+s<0&&u&&o==="EOL")return o;let a=y(y({},q),n);if(s>=e.length&&!u)return!1;let l=u?1:i.length,r=0,f=!1,d=!1,m=!1,g=a.maxMismatches,c=s,h=!1,$=!1,p=!1;function w(){return r===1&&g<a.maxMismatches-1}for(;e[c];){let b=t(c);if(a.trimBeforeMatching&&e[c].trim()===""){if(!e[b]&&u&&i==="EOL")return!0;c=t(c);continue}if(a&&!a.i&&a.trimCharsBeforeMatching&&a.trimCharsBeforeMatching.includes(e[c])||a!=null&&a.i&&a.trimCharsBeforeMatching&&a.trimCharsBeforeMatching.map(E=>E.toLowerCase()).includes(e[c].toLowerCase())){if(u&&i==="EOL"&&!e[b])return!0;c=t(c);continue}let O=b>c?i[i.length-l]:i[l-1];if(!a.i&&e[c]===O||a.i&&e[c].toLowerCase()===O.toLowerCase()){if(h||(h=!0),m||(m=!0),l===i.length){if($=!0,g!==a.maxMismatches)return!1}else l===1&&(p=!0);if(l-=1,r++,w())return!1;if(!l)return r!==i.length||g===a.maxMismatches||!f?c:!1}else if(!f&&!r&&(f=!0),a.maxMismatches&&g&&c){g-=1;for(let E=0;E<=g;E++){let T=b>c?i[i.length-l+1+E]:i[l-2-E],R=e[t(c)];if(T&&(!a.i&&e[c]===T||a.i&&e[c].toLowerCase()===T.toLowerCase())&&(!a.firstMustMatch||l!==i.length)){if(r++,w())return!1;l-=2,h=!0;break}else if(R&&T&&(!a.i&&R===T||a.i&&R.toLowerCase()===T.toLowerCase())&&(!a.firstMustMatch||l!==i.length)){if(!r&&!a.hungry)return!1;l-=1,h=!0;break}else if(T===void 0&&g>=0&&h&&(!a.firstMustMatch||$)&&(!a.lastMustMatch||p))return c}h||(d=c)}else return c===0&&l===1&&!a.lastMustMatch&&m?0:!1;if(d!==!1&&d!==c&&(d=!1),l<1)return c;c=t(c)}if(l>0)return u&&o==="EOL"?!0:a&&a.maxMismatches>=l&&m?d||0:!1}function P(e,s,i,n,u){var f,d;if(B(u)&&Object.prototype.hasOwnProperty.call(u,"trimBeforeMatching")&&u&&typeof u.trimBeforeMatching!="boolean")throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(u.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);let t=y(y({},q),u);if(typeof t.trimCharsBeforeMatching=="string"&&(t.trimCharsBeforeMatching=N(t.trimCharsBeforeMatching)),t.trimCharsBeforeMatching=t.trimCharsBeforeMatching.map(m=>_(m)?m:String(m)),!_(s)||!s.length)return!1;if(!Number.isInteger(i)||i<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof i}, equal to:
${JSON.stringify(i,null,4)}`);let o,a;if(_(n))o=[n];else if(Array.isArray(n))o=n;else if(!n)o=n;else if(typeof n=="function")o=[],o.push(n);else throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof n}, equal to:
${JSON.stringify(n,null,4)}`);if(u&&!B(u))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof u}", and equal to:
${JSON.stringify(u,null,4)}`);let l=0,r="";if(t!=null&&t.trimCharsBeforeMatching&&t.trimCharsBeforeMatching.some((m,g)=>m.length>1?(l=g,r=m,!0):!1))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${l} is longer than 1 character, ${r.length} (equals to ${r}). Please split it into separate characters and put into array as separate elements.`);if(!o||!Array.isArray(o)||Array.isArray(o)&&!o.length||Array.isArray(o)&&o.length===1&&_(o[0])&&!o[0].trim()){if(typeof t.cb=="function"){let g,c=i;if((e==="matchLeftIncl"||e==="matchRight")&&(c+=1),e[5]==="L")for(let w=c;w--;){let b=s[w];if((!t.trimBeforeMatching||t.trimBeforeMatching&&b!==void 0&&b.trim())&&(!((f=t.trimCharsBeforeMatching)!=null&&f.length)||b!==void 0&&!t.trimCharsBeforeMatching.includes(b))){g=w;break}}else if(e.startsWith("matchRight"))for(let w=c;w<s.length;w++){let b=s[w];if((!t.trimBeforeMatching||t.trimBeforeMatching&&b.trim())&&(!((d=t.trimCharsBeforeMatching)!=null&&d.length)||!t.trimCharsBeforeMatching.includes(b))){g=w;break}}if(g===void 0)return!1;let h=s[g],$=g+1,p="";return $&&$>0&&(p=s.slice(0,$)),e[5]==="L"||g&&g>0&&(p=s.slice(g)),t.cb(h,p,g)}let m="";throw u||(m=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${m}`)}for(let m=0,g=o.length;m<g;m++){a=typeof o[m]=="function";let c=o[m],h,$,p="",w=i;e==="matchRight"?w+=1:e==="matchLeft"&&(w-=1);let b=le(s,w,c,t,a,O=>e[5]==="L"?O-1:O+1);if(b&&a&&typeof c=="function"&&c()==="EOL")return c()&&(!t.cb||t.cb(h,p,$))?c():!1;if(Number.isInteger(b)&&($=e.startsWith("matchLeft")?b-1:b+1,e[5]==="L"?p=s.slice(0,b):p=s.slice($)),$<0&&($=void 0),s[$]&&(h=s[$]),Number.isInteger(b)&&(!t.cb||t.cb(h,p,$)))return c}return!1}function C(e,s,i,n){return P("matchLeftIncl",e,s,i,n)}function A(e,s,i,n){return P("matchRightIncl",e,s,i,n)}function k(e,s=1){let i="\xA0";function n(t){return Array.from(t).reverse().join("")}function u(t,o,a){let l=a?`
`:"\r",r=a?"\r":`
`;if(!t)return t;let f=0,d=0,m="";for(let g=0,c=t.length;g<c;g++)(t[g]===l||t[g]===r&&t[g-1]!==l)&&d++,`\r
`.includes(t[g])||t[g]===i?(f=0,t[g]===i?m+=t[g]:t[g]===l?d<=o&&(m+=t[g],t[g+1]===r&&(m+=t[g+1],g++)):t[g]===r&&(t==null?void 0:t[g-1])!==l&&d<=o&&(m+=t[g])):(f++,!t[g+1]&&!d&&(m+=" "));return m}if(typeof e=="string"&&e.length){let t=1;typeof+s=="number"&&Number.isInteger(+s)&&+s>=0&&(t=+s);let o="",a="";if(!e.trim())o=e;else if(!e[0].trim()){for(let l=0,r=e.length;l<r;l++)if(e[l].trim()){o=e.slice(0,l);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===i)){for(let l=e.length;l--;)if(e[l].trim()){a=e.slice(l+1);break}}return`${u(o,t,!1)}${e.trim()}${n(u(n(a),t,!0))}`}return e}var ue={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function Q(e,s){if(!Array.isArray(e)||!e.length)return e;let i=y(y({},ue),s),n,u;if(i.strictlyTwoElementsInRangeArrays&&!e.every((a,l)=>!Array.isArray(a)||a.length!==2?(n=l,u=a.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) has not two but ${u} elements!`);if(!e.every((a,l)=>!Array.isArray(a)||!Number.isInteger(a[0])||a[0]<0||!Number.isInteger(a[1])||a[1]<0?(n=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,o=0;return Array.from(e).sort((a,l)=>(i.progressFn&&(o+=1,i.progressFn(Math.floor(o*100/t))),a[0]===l[0]?a[1]<l[1]?-1:a[1]>l[1]?1:0:a[0]<l[0]?-1:1))}var U={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function ge(e,s){function i(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let n;if(s)if(i(s)){if(n=y(y({},U),s),n.progressFn&&i(n.progressFn)&&!Object.keys(n.progressFn).length)n.progressFn=null;else if(n.progressFn&&typeof n.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn,null,4)}`);if(![1,2,"1","2"].includes(n.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);if(typeof n.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(s,null,4)} (type ${typeof s})`);else n=y({},U);let u=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,o,a;n.progressFn?t=Q(u,{progressFn:r=>{a=Math.floor(r/5),a!==o&&(o=a,n.progressFn(a))}}):t=Q(u);let l=t.length-1;for(let r=l;r>0;r--)n.progressFn&&(a=Math.floor((1-r/l)*78)+21,a!==o&&a>o&&(o=a,n.progressFn(a))),(t[r][0]<=t[r-1][0]||!n.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||n.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+n.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}function M(e){return e!=null}function D(e){return Number.isInteger(e)&&e>=0}function I(e){return typeof e=="string"}var he={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},J=class{constructor(e){x(this,"ranges");x(this,"opts");let s=y(y({},he),e);if(s.mergeType&&s.mergeType!==1&&s.mergeType!==2)if(I(s.mergeType)&&s.mergeType.trim()==="1")s.mergeType=1;else if(I(s.mergeType)&&s.mergeType.trim()==="2")s.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof s.mergeType}", equal to ${JSON.stringify(s.mergeType,null,4)}`);this.opts=s,this.ranges=[]}add(e,s,i){var t;if(e==null&&s==null)return;if(M(e)&&!M(s)){if(Array.isArray(e)){if(e.length){if(e.some(o=>Array.isArray(o))){e.forEach(o=>{Array.isArray(o)&&this.add(...o)});return}e.length&&D(+e[0])&&D(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(s,null,0)})`)}else if(!M(e)&&M(s))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(s,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let n=+e,u=+s;if(D(i)&&(i=String(i)),D(n)&&D(u)){if(M(i)&&!I(i)&&!D(i))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof i}, equal to:
${JSON.stringify(i,null,4)}`);if(M(this.ranges)&&Array.isArray(this.last())&&n===this.last()[1]){if(this.last()[1]=u,this.last()[2],this.last()[2]!==null&&M(i)){let o=this.last()[2]&&this.last()[2].length&&(!((t=this.opts)!=null&&t.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${i}`:i;this.opts.limitToBeAddedWhitespace&&(o=k(o,this.opts.limitLinebreaksCount)),I(o)&&!o.length||(this.last()[2]=o)}}else{this.ranges||(this.ranges=[]);let o=i!==void 0&&!(I(i)&&!i.length)?[n,u,i&&this.opts.limitToBeAddedWhitespace?k(i,this.opts.limitLinebreaksCount):i]:[n,u];this.ranges.push(o)}}else throw D(n)&&n>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof u}" equal to: ${JSON.stringify(u,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof n}" equal to: ${JSON.stringify(n,null,4)}`)}push(e,s,i){this.add(e,s,i)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=ge(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>M(e[2])?[e[0],e[1],k(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&D(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var ce={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function H(e,s){if(!Array.isArray(e)||!e.length)return e;let i=y(y({},ce),s),n,u;if(i.strictlyTwoElementsInRangeArrays&&!e.every((a,l)=>!Array.isArray(a)||a.length!==2?(n=l,u=a.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) has not two but ${u} elements!`);if(!e.every((a,l)=>!Array.isArray(a)||!Number.isInteger(a[0])||a[0]<0||!Number.isInteger(a[1])||a[1]<0?(n=l,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) does not consist of only natural numbers!`);let t=e.length**2,o=0;return Array.from(e).sort((a,l)=>(i.progressFn&&(o+=1,i.progressFn(Math.floor(o*100/t))),a[0]===l[0]?a[1]<l[1]?-1:a[1]>l[1]?1:0:a[0]<l[0]?-1:1))}var G={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function z(e,s){function i(r){return!!r&&typeof r=="object"&&!Array.isArray(r)}if(!Array.isArray(e)||!e.length)return null;let n;if(s)if(i(s)){if(n=y(y({},G),s),n.progressFn&&i(n.progressFn)&&!Object.keys(n.progressFn).length)n.progressFn=null;else if(n.progressFn&&typeof n.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn,null,4)}`);if(![1,2,"1","2"].includes(n.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);if(typeof n.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(s,null,4)} (type ${typeof s})`);else n=y({},G);let u=e.filter(r=>Array.isArray(r)).map(r=>[...r]).filter(r=>r[2]!==void 0||r[0]!==r[1]),t,o,a;n.progressFn?t=H(u,{progressFn:r=>{a=Math.floor(r/5),a!==o&&(o=a,n.progressFn(a))}}):t=H(u);let l=t.length-1;for(let r=l;r>0;r--)n.progressFn&&(a=Math.floor((1-r/l)*78)+21,a!==o&&a>o&&(o=a,n.progressFn(a))),(t[r][0]<=t[r-1][0]||!n.joinRangesThatTouchEdges&&t[r][0]<t[r-1][1]||n.joinRangesThatTouchEdges&&t[r][0]<=t[r-1][1])&&(t[r-1][0]=Math.min(t[r][0],t[r-1][0]),t[r-1][1]=Math.max(t[r][1],t[r-1][1]),t[r][2]!==void 0&&(t[r-1][0]>=t[r][0]||t[r-1][1]<=t[r][1])&&t[r-1][2]!==null&&(t[r][2]===null&&t[r-1][2]!==null?t[r-1][2]=null:t[r-1][2]!=null?+n.mergeType==2&&t[r-1][0]===t[r][0]?t[r-1][2]=t[r][2]:t[r-1][2]+=t[r][2]:t[r-1][2]=t[r][2]),t.splice(r,1),r=t.length);return t.length?t:null}var fe=!0,V="Invariant failed";function K(e,s){if(!e){if(fe)throw new Error(V);var i=typeof s=="function"?s():s,n=i?"".concat(V,": ").concat(i):V;throw new Error(n)}}function X(e,s,i){let n=0,u=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(s&&!Array.isArray(s))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s,null,4)}`);if(i&&typeof i!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof i}, equal to: ${JSON.stringify(i,null,4)}`);if(!s||!s.filter(f=>f).length)return e;let t;Array.isArray(s)&&Number.isInteger(s[0])&&Number.isInteger(s[1])?t=[Array.from(s)]:t=Array.from(s);let o=t.length,a=0;t.filter(f=>f).forEach((f,d)=>{if(i&&(n=Math.floor(a/o*10),n!==u&&(u=n,i(n))),!Array.isArray(f))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${d}th element not an array: ${JSON.stringify(f,null,4)}, which is ${typeof f}`);if(!Number.isInteger(f[0])){if(!Number.isInteger(+f[0])||+f[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${d}th element, array ${JSON.stringify(f,null,0)}. Its first element is not an integer, string index, but ${typeof f[0]}, equal to: ${JSON.stringify(f[0],null,4)}.`);t[d][0]=+t[d][0]}if(!Number.isInteger(f[1])){if(!Number.isInteger(+f[1])||+f[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${d}th element, array ${JSON.stringify(f,null,0)}. Its second element is not an integer, string index, but ${typeof f[1]}, equal to: ${JSON.stringify(f[1],null,4)}.`);t[d][1]=+t[d][1]}a+=1});let l=z(t,{progressFn:f=>{i&&(n=10+Math.floor(f/10),n!==u&&(u=n,i(n)))}});K(l);let r=l.length;if(r>0){let f=e.slice(l[r-1][1]);e=l.reduce((d,m,g,c)=>{i&&(n=20+Math.floor(g/r*80),n!==u&&(u=n,i(n)));let h=g===0?0:c[g-1][1],$=c[g][0];return`${d}${e.slice(h,$)}${c[g][2]||""}`},""),e+=f}return e}var me={classicTrim:!1,cr:!1,lf:!1,tab:!1,space:!0,nbsp:!1};function v(e,s){if(typeof e!="string")throw new Error(`string-trim-spaces-only: [THROW_ID_01] input must be string! It was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);let i=y(y({},me),s);function n(o){return i.classicTrim&&!o.trim()||!i.classicTrim&&(i.space&&o===" "||i.cr&&o==="\r"||i.lf&&o===`
`||i.tab&&o==="	"||i.nbsp&&o==="\xA0")}let u,t;if(e.length){if(n(e[0]))for(let o=0,a=e.length;o<a;o++){if(!n(e[o])){u=o;break}if(o===e.length-1)return{res:"",ranges:[[0,e.length]]}}if(n(e[e.length-1])){for(let o=e.length;o--;)if(!n(e[o])){t=o+1;break}}return u?t?{res:e.slice(u,t),ranges:[[0,u],[t,e.length]]}:{res:e.slice(u),ranges:[[0,u]]}:t?{res:e.slice(0,t),ranges:[[t,e.length]]}:{res:e,ranges:[]}}return{res:"",ranges:[]}}var Y="7.0.4";var de=Y,Z={heads:["{{"],tails:["}}"]};function ye(e,s){let i=Object.prototype.hasOwnProperty;if(e===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof e!="string")return e;if(s&&!L(s))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof s}!`);let n=y({},s);if(n&&i.call(n,"heads"))if(N(n.heads).every(h=>typeof h=="string"||Array.isArray(h)))typeof n.heads=="string"&&(n.heads=N(n.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The resolvedOpts.heads contains elements which are not string-type!");if(n&&i.call(n,"tails"))if(N(n.tails).every(h=>typeof h=="string"||Array.isArray(h)))typeof n.tails=="string"&&(n.tails=N(n.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The resolvedOpts.tails contains elements which are not string-type!");let u=v(e).res;if(u.length===0)return e;e=u;let t=y(y({},Z),n);t.heads=t.heads.map(h=>h.trim()),t.tails=t.tails.map(h=>h.trim());let o=!1,a=!1,l=new J({limitToBeAddedWhitespace:!0}),r=new J({limitToBeAddedWhitespace:!0}),f=!0,d=!0,m="";function g(h,$){let p;return A(h,0,$.heads,{trimBeforeMatching:!0,cb:(O,E,T)=>(p=T,!0)})&&A(h,p,$.tails,{trimBeforeMatching:!0,cb:(O,E,T)=>(p=T,!0)})?h.slice(p):h}for(;e!==g(e,t);)e=v(g(e,t)).res;function c(h,$){let p;return!C(h,h.length-1,$.tails,{trimBeforeMatching:!0,cb:(O,E,T)=>(p=T,!0)})||!p?h:C(h,p,$.heads,{trimBeforeMatching:!0,cb:(O,E,T)=>(p=T,!0)})?h.slice(0,p+1):h}for(;e!==c(e,t);)e=v(c(e,t)).res;if(!t.heads.length||!A(e,0,t.heads,{trimBeforeMatching:!0})||!t.tails.length||!C(e,e.length-1,t.tails,{trimBeforeMatching:!0}))return v(e).res;for(let h=0,$=e.length;h<$;h++)if(e[h].trim()!==""){let p;if(A(e,h,t.heads,{trimBeforeMatching:!0,cb:(O,E,T)=>(p=T,!0)})&&p){d=!0,f&&(f=!0);let O;A(e,p,t.tails,{trimBeforeMatching:!0,cb:(T,R,ee)=>(O=ee,!0)})&&l.push(h,O),r.current()&&o&&m!=="tails"&&l.push(r.current()),o||r.current()&&(l.push(r.current()),r.wipe()),r.push(h,p),m="heads",h=p-1;continue}if(A(e,h,t.tails,{trimBeforeMatching:!0,cb:(O,E,T)=>(p=Number.isInteger(T)?T:e.length,!0)})&&p){d=!0,f?(m==="heads"&&r.wipe(),f=!1):r.push(h,p),m="tails",h=p-1;continue}f&&(f=!0),d&&!o?(o=!0,d=!1):d&&!a?(a=!0,f=!0,d=!1,m==="heads"&&r.wipe()):d&&a&&r.wipe()}return r.current()&&l.push(r.current()),l.current()?X(e,l.current()).trim():e.trim()}return ae($e);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.1.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 5.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 9.0.4
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-trim-spaces-only
 * @fileoverview Like String.trim() but you can choose granularly what to trim
 * @version 5.0.3
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-trim-spaces-only/}
 */
